//+------------------------------------------------------------------+
//|                                                EUR!!USD_1.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property link      ""
   

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
extern double TP=27;
extern double SL=17;
extern bool traling_stop=True;
extern int TrailingStop   = 15;
extern int TrailingStep   = 2;
extern double lots = 0.7;
extern int p = 14;
extern int levup = 27;
extern int levdn = 80;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int cnt, total, i, k;
double rsi_3, rsi_2, rsi_1, rsi, rsi1, rsi2, rsi3;

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {//1
  int i;
  {
  for (i=0;i<OrdersTotal();i++)
   {
   if (traling_stop==true)
   if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
   TrailingPositions();
   }
  }
  
  total = OrdersTotal();
  if(total > 0)
    ClosePosition();   
  if(total < 1)
    OpenPosition();
     
   }//1
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
  
void OpenPosition()
  {//1 
  
  if(Signal() > 0)
    {//2
    OrderSend(Symbol(),OP_BUY,lots,Ask,10,Ask-SL*Point,Ask+TP*Point,"Buy",0,0,Blue); 
    return(0);
    }//2
  if(Signal() < 0)
    {//2
    OrderSend(Symbol(),OP_SELL,lots,Bid,10,Bid+SL*Point,Bid-TP*Point,"Sell",0,0,Red);
    return(0);
    }//2
   
   return(0);
  }//1
  
  
 void TrailingPositions() {
  bool   ProfitTrailing = false;
  int    TrailingStop   = 10;
  int    TrailingStep   = 2;
  double pBid, pAsk, pp;



  pp = MarketInfo(OrderSymbol(), MODE_POINT);
  if (OrderType()==OP_BUY) {
    pBid = MarketInfo(OrderSymbol(), MODE_BID);
    if (!ProfitTrailing || (pBid-OrderOpenPrice())>TrailingStop*pp) {
      if (OrderStopLoss()<pBid-(TrailingStop+TrailingStep-1)*pp) {
        ModifyStopLoss(pBid-TrailingStop*pp);
        return;
      }
    }
  }
  if (OrderType()==OP_SELL) {
    pAsk = MarketInfo(OrderSymbol(), MODE_ASK);
    if (!ProfitTrailing || OrderOpenPrice()-pAsk>TrailingStop*pp) {
      if (OrderStopLoss()>pAsk+(TrailingStop+TrailingStep-1)*pp || OrderStopLoss()==0) {
        ModifyStopLoss(pAsk+TrailingStop*pp);
        return;
      }
    }
  }
}

void ModifyStopLoss(double ldStopLoss) {
  bool fm;
  fm=OrderModify(OrderTicket(),OrderOpenPrice(),ldStopLoss,OrderTakeProfit(),0,CLR_NONE);
}   
    
  
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

void ClosePosition()
  {//1
  for(cnt=0;cnt<total;cnt++)
    
    
    
    
    {//2
    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
    if(OrderType() <= OP_SELL && 
       OrderSymbol() == Symbol())
        {//3
         if(OrderType() == OP_BUY)
           {//4
           if(Signal() < 0)
             {//5
             OrderClose(OrderTicket(),OrderLots(),Bid,0,Red);
             return(0);
             }//5
           }//4
         if(OrderType() == OP_SELL)
           {//4
           if(Signal() > 0)
             {//5   
             OrderClose(OrderTicket(),OrderLots(),Ask,0,Blue);
             return(0);
             }//5
           }//4
         }//3
       }//2
     return(0);
   }//1
   
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int Signal()
  {//1
  for(i=0; i<500; i++)
     
      rsi1=iRSI(NULL,0,14,PRICE_CLOSE,i+1);
      rsi2=iRSI(NULL,0,14,PRICE_CLOSE,i+2);
      rsi3=iRSI(NULL,0,14,PRICE_CLOSE,i+3);
    {//2
    if  (rsi1<rsi2 && rsi2>=rsi3 && rsi2<levup) 
    
      {//3
      return(1);
      }//3
      
     if  (rsi1>rsi2 && rsi2<=rsi3 && rsi2>levdn) 
      {//3
      return(-1);
      }//3
    }//2
  return(0);
  }//1
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
/*
double UP()
  {//1
  int k;
  for(k=0;;k++)
    {//2
    rsi_3 = iRSI(NULL,0,p,0,k+3);
    rsi_2 = iRSI(NULL,0,p,0,k+2);
    rsi_1 = iRSI(NULL,0,p,0,k+1);
    if((rsi_3 < rsi_2) && (rsi_2 > rsi_1))
      {//3
      return(rsi_2);
      }//3
    }//2
  }//1
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

double DN()
  {//1
  int l;
  for(l=0;;l++)
    {//2
    rsi_3 = iRSI(NULL,0,p,0,l+3);
    rsi_2 = iRSI(NULL,0,p,0,l+2);
    rsi_1 = iRSI(NULL,0,p,0,l+1);
    if((rsi_3 > rsi_2) && (rsi_2 < rsi_1))
      {//3
      return(rsi_2);
      }//3
    }//2
  }//1
*/
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+  
  

